unit GaussJordan;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ComCtrls, StdCtrls, Spin, ExtCtrls;

type
  poleR = array of real;
  poleR2= array of poleR;
 
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    Button4: TButton;
    Button1: TButton;
    Label1: TLabel;
    pocR: TEdit;
    UpDownR: TUpDown;
    Label2: TLabel;
    PocS: TEdit;
    UpDownS: TUpDown;
    Button2: TButton;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Button3: TButton;
    Memo1: TMemo;
    procedure UpDownRClick(Sender: TObject; Button: TUDBtnType);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure UpDownSClick(Sender: TObject; Button: TUDBtnType);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure upravMriezku(r, s : byte);
    procedure inicializujMatice;
    procedure vypisVysledky;

  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Form1: TForm1;
  a : poleR2; // system
  x : poleR;  // solution
  b : array of shortInt;  // basis
  m, n : byte;
  nemaRies : boolean;

implementation

{$R *.dfm}

procedure TForm1.UpDownRClick(Sender: TObject; Button: TUDBtnType);
begin
  stringGrid1.RowCount:= UpDownR.Position+1;
end;

procedure TForm1.UpDownSClick(Sender: TObject; Button: TUDBtnType);

var i : byte;

begin
  with stringGrid1 do
  begin
    ColCount:= UpDownS.Position+1;
    for i := 0 to ColCount-2 do cells[i,0] := 'x'+intToStr(i+1);
    cells[colCount-1,0] := 'b';
  end;
end;


procedure TForm1.Button4Click(Sender: TObject);

var pocRiad : byte;
    i, j : byte;

begin
  pocRiad := upDownR.Max;
  for i:= 0 to pocRiad do for j := 1 to pocRiad do
    stringGrid1.Cells[i,j] := '';
  memo1.Clear;
  memo1.Lines.Add('Solution');
end;



procedure TForm1.FormCreate(Sender: TObject);

begin
  upravMriezku(5,5);
end;


procedure TForm1.Button2Click(Sender: TObject);

var textovySubor : textFile;

begin
//  assign
//  if saveDialog1.Execute then
  begin

  end;
end;


procedure TForm1.Button1Click(Sender: TObject);

var textSub : textFile;
    i, j : byte;
    pom : real;

begin
  if openDialog1.Execute then
  begin
    assignFile(textSub, openDialog1.fileName);
    reset(textSub);
    readln(textSub, m, n);
    upravMriezku(m, n);

    for i := 1 to m do
    begin
      for j := 0 to n-1 do
      begin
        read(textSub, pom);
        stringGrid1.Cells[j, i] := floatToStr(pom);
      end;
      readln(textSub, pom);
      stringGrid1.Cells[n, i] := floatToStr(pom);
    end;
  end;
  memo1.Clear;
  memo1.Lines.Add('Solution');
end;

procedure TForm1.upravMriezku(r, s : byte);

var i : byte;

begin
  upDownR.Position := r;
  upDownS.Position := s;
  with stringGrid1 do
  begin
    RowCount := upDownR.Position+1;
    ColCount := upDownS.Position+1;
    for i := 0 to ColCount-2 do cells[i,0] := 'x'+intToStr(i+1);
    cells[RowCount-1,0] := 'b';
  end;
end;

procedure Tform1.inicializujMatice;

var i, j : byte;

begin
    m := upDOwnR.Position;
    n := upDownS.Position;
    setLength(b,m);
    setLength(x,m);
    setLength(a,m);           // zaciatok nedimenzovania matice a
    for i := 0 to m - 1 do setLength(a[i],n+1);
                             // koniec nedimenzovania matice a
    for i := 1 to m do for j := 0 to n do
        a[i-1,j] := strToFloat(stringGrid1.Cells[j, i]);
end;

procedure TForm1.Button3Click(Sender: TObject);

var i, j, k : byte;
    r, s : shortInt;
    pivot : real;
    pom : real;

begin
  inicializujMatice;
  nemaRies := false;
  


Showmessage('Here will be the Gauss-Jordan elimination');




  vypisVysledky;
end;

procedure TForm1.vypisVysledky;

var i, j : byte;
    riadok : string;
    nekonecneVela : boolean;
begin
  if nemaRies then
  begin
    showMessage('No solution');
    exit;
  end;
  nekonecneVela := false;
  memo1.Clear;
  memo1.Lines.Add('Solution');
  for i := 1 to m do for j := 0 to m do
    stringGrid1.Cells[j,i] := floatToStr(a[i-1,j]);
  for i := 0 to m-1 do if b[i] = -1 then nekonecneVela := true;
  for i := 0 to m-1 do
  begin
    if nekonecneVela then
    begin
      ShowMessage('Infinity of solutions');
      exit;
    end;
    x[i] := a[b[i],n];
    riadok := 'x['+intToStr(i+1)+']='+floatToStr(x[i]);
    memo1.Lines.Add(riadok);
  end;
end;


end.

